stages:
  - build
  - deploy

build:
  stage: build
  image: docker:latest
  services: 
    - docker:dind
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:v3
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$IMAGE_TAG" .
    - docker push "$IMAGE_TAG"

  

deploy:
  stage: deploy
  image: roffe/kubectl
  script:
    - kubectl config set-cluster cluster-first --server="$KUBE_URL" --insecure-skip-tls-verify=true
    - kubectl config set-credentials pantmal --token="$KUBE_TOKEN"
    - kubectl config set-context default --cluster=cluster-first --user=pantmal
    - kubectl config use-context default
    - sed -i "s/__VERSION__/gitlab-$CI_COMMIT_SHORT_SHA/" deploy.yaml
    - kubectl apply -f internal-kubernetes.yaml
    - kubectl apply -f deploy.yaml


